#ifndef __RADIO_TRANSFER_H
#define __RADIO_TRANSFER_H

#include <linux/dvb/video.h>
#include <vdr/player.h>
#include <vdr/receiver.h>
#include <vdr/remux.h>
#include <vdr/ringbuffer.h>
#include <vdr/thread.h>
#include <vdr/device.h>

class cRadioTransfer : public cReceiver, public cPlayer, public cThread {
private:
  cRingBufferLinear *ringBuffer;
  cRemux *remux;
  bool canToggleAudioTrack;
  uchar audioTrack;
  bool active;
  const char *imagepath;
  int ppids[5];
  void StripAudioPackets(uchar *b, int Length, uchar Except = 0x00);
  void send_pes_packet(unsigned char *data, int len, int timestamp);
  void ShowImage (const char *file);
protected:
  virtual void Activate(bool On);
  virtual void Receive(uchar *Data, int Length);
  virtual void Action(void);
public:
  cRadioTransfer(int VPid, int APid[], int DPid[], int CA, const char *Image);
  virtual ~cRadioTransfer();
  virtual int NumAudioTracks(void) const;
  virtual const char **GetAudioTracks(int *CurrentTrack = NULL) const;
  virtual void SetAudioTrack(eTrackType Type, const tTrackId *TrackId);
  };

class cRadioTransferControl : public cControl {
private:
  cRadioTransfer *transfer;
  static cDevice *receiverDevice;
public:
  cRadioTransferControl(cDevice *ReceiverDevice, int VPid, int APid[], int DPid[], int CA, const char *Image);
  ~cRadioTransferControl();
  virtual void Hide(void) {}
  static cDevice *ReceiverDevice(void) { return receiverDevice; }
  };

#endif //__RADIO_TRANSFER_H
